/* flight_simulator.c

        Universidade Federal do Espirito Santo - UFES
                  Engenharia de Computacao        
         2o. Trabalho de Computacao Grafica - 2003/2
        Rodrigo Laiola Guimaraes - Luiz Manoel Gerosa
                Professor: Thomas W. Rauber
*/


#include <stdio.h>
#include <malloc/malloc.h>
#include <string.h>
#include <GLUT/glut.h> 

// Variaveis Globais e definicoes:

#define BYTE unsigned char
#define TRUE 1
#define FALSE 0

#define CITY_WIDTH 5
#define CITY_HEIGHT 10

#define FOREST_WIDTH CITY_WIDTH
#define FOREST_HEIGHT CITY_HEIGHT

#define BEACH_WIDTH CITY_WIDTH
#define BEACH_HEIGHT CITY_HEIGHT

#define TRACK_WIDTH CITY_WIDTH
#define TRACK_HEIGHT CITY_HEIGHT

#define BOUND_X 5.0 * 3.0 * CITY_HEIGHT
#define BOUND_Y 5.0 * CITY_HEIGHT
#define BOUND_Z 12.0 * 3.0 * CITY_HEIGHT

#define TOWER_X 3.75 * CITY_HEIGHT
#define TOWER_Y 4.5
#define TOWER_Z 6.0 * CITY_HEIGHT


#define DELAY 10                // Intervalo de tempo

GLuint wall_texture1, wall_texture2;
GLuint roof_texture1, roof_texture2;
GLuint building_texture1, building_texture2;
GLuint asphalt_texture1, asphalt_texture2;
GLuint wood_texture1, wood_texture2;
GLuint leafs_texture1, leafs_texture2;
GLuint earth_texture;
GLuint sand_texture1, sand_texture2;
GLuint sea_texture;
GLuint clouds_texture;
GLuint sky_texture;
GLuint paper_texture;

GLboolean wireFlag = GL_FALSE;
GLboolean textureFlag = GL_TRUE;
GLboolean pauseFlag = GL_FALSE;
GLboolean windowFlag = GL_TRUE;

int width, height;

float step = 0.0;

GLfloat mvmatrix[16];


// ---------------------------------
// ------------- Desenhos ----------
// ---------------------------------

// -------------------
// Desenha Coqueiro
// -------------------

void draw_palm(float x, float y, float z)
{
  int i;
  
  glPushMatrix();
  
  glScalef(x, y, z);

  if (textureFlag == GL_FALSE)
    glColor3f(1.0, 1.0, 0.5);

  else
    glBindTexture(GL_TEXTURE_2D, wood_texture1);
  
  // Tronco

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.1, 2.0, 0.1);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.1, 2.0, -0.1);
    glTexCoord2d(1.0,1.0); glVertex3f(0.1, 2.0, -0.1);
    glTexCoord2d(0.0,1.0); glVertex3f(0.1, 2.0, 0.1);
  glEnd();    

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.1, 0.0, 0.1);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.1, 0.0, -0.1);
    glTexCoord2d(1.0,1.0); glVertex3f(0.1, 0.0, -0.1);
    glTexCoord2d(0.0,1.0); glVertex3f(0.1, 0.0, 0.1);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.1, 2.0, -0.1);
    glTexCoord2d(1.0,0.0); glVertex3f(0.1, 2.0, 0.1);
    glTexCoord2d(1.0,1.0); glVertex3f(0.1, 0.0, 0.1);
    glTexCoord2d(0.0,1.0); glVertex3f(0.1, 0.0, -0.1);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.1, 2.0, -0.1);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.1, 2.0, 0.1);
    glTexCoord2d(1.0,1.0); glVertex3f(-0.1, 0.0, 0.1);
    glTexCoord2d(0.0,1.0); glVertex3f(-0.1, 0.0, -0.1);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.1, 2.0, -0.1);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.1, 0.0, -0.1);
    glTexCoord2d(1.0,1.0); glVertex3f(0.1, 0.0, -0.1);
    glTexCoord2d(0.0,1.0); glVertex3f(0.1, 2.0, -0.1);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.1, 2.0, 0.1);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.1, 0.0, 0.1);
    glTexCoord2d(1.0,1.0); glVertex3f(0.1, 0.0, 0.1);
    glTexCoord2d(0.0,1.0); glVertex3f(0.1, 2.0, 0.1);
  glEnd();

  if (textureFlag == GL_FALSE){
    glColor3f(0.0, 1.0, 0.0);
  }
  else{ 
    glBindTexture(GL_TEXTURE_2D, leafs_texture1);    
  }

  // Copa

  for(i = 0; i < 6; i++){
    glRotatef(60.0, 0.0, 1.0, 0.0);

    glBegin(GL_POLYGON);
      glTexCoord2d(0.0,0.0); glVertex3f(-1.5, 2.05, 0.1);
      glTexCoord2d(1.0,0.0); glVertex3f(-1.5, 2.05, -0.1);
      glTexCoord2d(1.0,1.0); glVertex3f(0.0, 2.05, -0.1);
      glTexCoord2d(0.0,1.0); glVertex3f(0.0, 2.05, 0.1);
    glEnd();      
  }

  glPopMatrix();
}


// -------------------
// Desenha Praia
// -------------------

void draw_beach(void)
{
  int i, j, k, l;
    

  k = 2;
  l = 5;

  if (textureFlag == GL_FALSE){
    glColor3f(0.5, 0.0, 0.0);
  }
  else{ 
    glBindTexture(GL_TEXTURE_2D, sand_texture1);    
  }

  glPushMatrix();   

  glBegin(GL_POLYGON);

    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.0, 0.0);
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, 0.0, BEACH_HEIGHT/2 * 3.0);
    glTexCoord2d(1.0,1.0); glVertex3f(BEACH_WIDTH * 6.0, 0.0, BEACH_HEIGHT/2 * 3.0);
    glTexCoord2d(0.0,1.0); glVertex3f(BEACH_WIDTH * 6.0, 0.0, 0.0);
  glEnd();   

  if (textureFlag == GL_FALSE){
    glColor3f(0.0, 0.0, 1.0);
  }
  else{ 
    glBindTexture(GL_TEXTURE_2D, sea_texture);    
  }


  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.0, BEACH_HEIGHT/2 * 3.0);
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, 0.0, BEACH_HEIGHT * 3.0);
    glTexCoord2d(1.0,1.0); glVertex3f(BEACH_WIDTH * 6.0, 0.0, BEACH_HEIGHT * 3.0);
    glTexCoord2d(0.0,1.0); glVertex3f(BEACH_WIDTH * 6.0, 0.0, BEACH_HEIGHT/2 * 3.0);
  glEnd(); 

  glTranslatef(1.5, 0.0, 1.5);      

  for(i = 0;i < BEACH_HEIGHT/2; i++){
    glPushMatrix();   
 
    for(j = 0; j < BEACH_WIDTH; j++){
      if ((i + j) % k == 0) draw_palm(1.0, 4.0, 1.0); 
      else draw_palm(1.0, 3.0, 1.0); 
      
      glTranslatef(3.0, 0.0, 0.0);
  
      if (i % l == 0) draw_palm(1.0, 1.0, 1.0); 
      else draw_palm(1.0, 2.0, 1.0); 

      glTranslatef(3.0, 0.0, 0.0);
    }    

    glPopMatrix(); 
    glTranslatef(0.0, 0.0, 3.0);
  }

  glPopMatrix();          
}

// -------------------
// Desenha Mar
// -------------------

void draw_sea(void)
{    
  if (textureFlag == GL_FALSE)
    glColor3f(0.0, 0.0, 1.0);
  else 
    glBindTexture(GL_TEXTURE_2D, sea_texture);    

  glPushMatrix();          


  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.0, 0.0);
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, 0.0, BEACH_HEIGHT * 3.0);
    glTexCoord2d(1.0,1.0); glVertex3f(BEACH_WIDTH * 6.0, 0.0, BEACH_HEIGHT * 3.0);
    glTexCoord2d(0.0,1.0); glVertex3f(BEACH_WIDTH * 6.0, 0.0, 0.0);
  glEnd(); 

  glPopMatrix();          
}

// -------------------
// Desenha Arvore
// -------------------

void draw_tree(float x, float y, float z, int t)
{
  glPushMatrix();
  
  glScalef(x, y, z);

  if (textureFlag == GL_FALSE){
    glColor3f(1.0, 1.0, 0.5);
  }
  else{
    if (t % 2 == 0) glBindTexture(GL_TEXTURE_2D, wood_texture1);
    else glBindTexture(GL_TEXTURE_2D, wood_texture2);
  }
  
  // Tronco

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.25, 1.0, 0.25);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.25, 1.0, -0.25);
    glTexCoord2d(1.0,1.0); glVertex3f(0.25, 1.0, -0.25);
    glTexCoord2d(0.0,1.0); glVertex3f(0.25, 1.0, 0.25);
  glEnd();    

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.25, 0.0, 0.25);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.25, 0.0, -0.25);
    glTexCoord2d(1.0,1.0); glVertex3f(0.25, 0.0, -0.25);
    glTexCoord2d(0.0,1.0); glVertex3f(0.25, 0.0, 0.25);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.25, 1.0, -0.25);
    glTexCoord2d(1.0,0.0); glVertex3f(0.25, 1.0, 0.25);
    glTexCoord2d(1.0,1.0); glVertex3f(0.25, 0.0, 0.25);
    glTexCoord2d(0.0,1.0); glVertex3f(0.25, 0.0, -0.25);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.25, 1.0, -0.25);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.25, 1.0, 0.25);
    glTexCoord2d(1.0,1.0); glVertex3f(-0.25, 0.0, 0.25);
    glTexCoord2d(0.0,1.0); glVertex3f(-0.25, 0.0, -0.25);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.25, 1.0, -0.25);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.25, 0.0, -0.25);
    glTexCoord2d(1.0,1.0); glVertex3f(0.25, 0.0, -0.25);
    glTexCoord2d(0.0,1.0); glVertex3f(0.25, 1.0, -0.25);

  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.25, 1.0, 0.25);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.25, 0.0, 0.25);
    glTexCoord2d(1.0,1.0); glVertex3f(0.25, 0.0, 0.25);
    glTexCoord2d(0.0,1.0); glVertex3f(0.25, 1.0, 0.25);
  glEnd();

  if (textureFlag == GL_FALSE){
    glColor3f(0.0, 1.0, 0.0);
  }
  else{ 

    if (t % 3 == 0) glBindTexture(GL_TEXTURE_2D, leafs_texture2);
    else glBindTexture(GL_TEXTURE_2D, leafs_texture1);
  }

  // Copa


  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-1.0, 2.0, 1.0);
    glTexCoord2d(1.0,0.0); glVertex3f(-1.0, 2.0, -1.0);
    glTexCoord2d(1.0,1.0); glVertex3f(1.0, 2.0, -1.0);
    glTexCoord2d(0.0,1.0); glVertex3f(1.0, 2.0, 1.0);
  glEnd();    

  glBegin(GL_POLYGON);

    glTexCoord2d(0.0,0.0); glVertex3f(-1.0, 1.0, 1.0);
    glTexCoord2d(1.0,0.0); glVertex3f(-1.0, 1.0, -1.0);
    glTexCoord2d(1.0,1.0); glVertex3f(1.0, 1.0, -1.0);
    glTexCoord2d(0.0,1.0); glVertex3f(1.0, 1.0, 1.0);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(1.0, 2.0, -1.0);
    glTexCoord2d(1.0,0.0); glVertex3f(1.0, 2.0, 1.0);
    glTexCoord2d(1.0,1.0); glVertex3f(1.0, 1.0, 1.0);
    glTexCoord2d(0.0,1.0); glVertex3f(1.0, 1.0, -1.0);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-1.0, 2.0, -1.0);
    glTexCoord2d(1.0,0.0); glVertex3f(-1.0, 2.0, 1.0);
    glTexCoord2d(1.0,1.0); glVertex3f(-1.0, 1.0, 1.0);
    glTexCoord2d(0.0,1.0); glVertex3f(-1.0, 1.0, -1.0);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-1.0, 2.0, -1.0);
    glTexCoord2d(1.0,0.0); glVertex3f(-1.0, 1.0, -1.0);
    glTexCoord2d(1.0,1.0); glVertex3f(1.0, 1.0, -1.0);
    glTexCoord2d(0.0,1.0); glVertex3f(1.0, 2.0, -1.0);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-1.0, 2.0, 1.0);
    glTexCoord2d(1.0,0.0); glVertex3f(-1.0, 1.0, 1.0);
    glTexCoord2d(1.0,1.0); glVertex3f(1.0, 1.0, 1.0);
    glTexCoord2d(0.0,1.0); glVertex3f(1.0, 2.0, 1.0);
  glEnd();

  glPopMatrix();
}

// -------------------
// Desenha Floresta
// -------------------

void draw_forest(void)
{
  int i, j, k, l;
    
  k = 2;
  l = 5;

  if (textureFlag == GL_FALSE)
    glColor3f(0.9, 0.5, 0.5);
  else 
    glBindTexture(GL_TEXTURE_2D, earth_texture);

  glPushMatrix();   

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.0, 0.0);
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, 0.0, FOREST_HEIGHT * 3.0);
    glTexCoord2d(1.0,1.0); glVertex3f(FOREST_WIDTH * 6.0, 0.0, FOREST_HEIGHT * 3.0);
    glTexCoord2d(0.0,1.0); glVertex3f(FOREST_WIDTH * 6.0, 0.0, 0.0);
  glEnd();  

  glTranslatef(1.5, 0.0, 1.5);

  for(i = 0;i < FOREST_HEIGHT; i++){
    glPushMatrix();   
 
    for(j = 0; j < FOREST_WIDTH; j++){
      if ((i + j) % k == 0) draw_tree(1.0, 4.0, 1.0, i); 
      else draw_tree(1.0, 3.0, 1.0, i + j); 
      
      glTranslatef(3.0, 0.0, 0.0);
  
      if (i % l == 0) draw_tree(1.0, 1.0, 1.0, i); 
      else draw_tree(1.0, 2.0, 1.0, i + j); 

      glTranslatef(3.0, 0.0, 0.0);
    }    


    glPopMatrix(); 
    glTranslatef(0.0, 0.0, 3.0);
  }

  glPopMatrix();   
}

// -------------------
// Desenha Casa
// -------------------

void draw_house(float x, float y, float z, int t)
{
  glPushMatrix();
  
  glScalef(x, y, z);

  if (textureFlag == GL_FALSE){
    glColor3f(0.0, 1.0, 1.0);
  }
  else{

    if (t % 2 == 0) glBindTexture(GL_TEXTURE_2D, wall_texture1);
    else glBindTexture(GL_TEXTURE_2D, wall_texture2);
  }
  
  // Base da casa

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 1.0, 0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.5, 1.0, -0.5);

    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 1.0, -0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(0.5, 1.0, 0.5);
  glEnd();    

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 0.0, 0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.5, 0.0, -0.5);
    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 0.0, -0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(0.5, 0.0, 0.5);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.5, 1.0, -0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(0.5, 1.0, 0.5);
    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 0.0, 0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(0.5, 0.0, -0.5);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 1.0, -0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.5, 1.0, 0.5);
    glTexCoord2d(1.0,1.0); glVertex3f(-0.5, 0.0, 0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(-0.5, 0.0, -0.5);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 1.0, -0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.5, 0.0, -0.5);
    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 0.0, -0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(0.5, 1.0, -0.5);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 1.0, 0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.5, 0.0, 0.5);

    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 0.0, 0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(0.5, 1.0, 0.5);
  glEnd();

  if (textureFlag == GL_FALSE){
    glColor3f(1.0, 0.0, 0.0);
  }
  else{ 
    if (t % 3 == 0) glBindTexture(GL_TEXTURE_2D, roof_texture1);
    else glBindTexture(GL_TEXTURE_2D, roof_texture2);
  }

  // Telhado

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 1.0, 0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.5, 1.0, -0.5);
    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 1.0, -0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(0.5, 1.0, 0.5);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 1.0, 0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, 1.5, 0.0);
    glTexCoord2d(1.0,1.0); glVertex3f(-0.5, 1.0, -0.5);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 1.0, -0.5);    
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, 1.5, 0.0);
    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 1.0, -0.5);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.5, 1.0, -0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, 1.5, 0.0);
    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 1.0, 0.5);    
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.5, 1.0, 0.5);    
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, 1.5, 0.0);
    glTexCoord2d(1.0,1.0); glVertex3f(-0.5, 1.0, 0.5);
  glEnd();

  glPopMatrix();
}

// -------------------
// Desenha Predio
// -------------------

void draw_building(float x, float y, float z, int t)
{
  glPushMatrix();
  
  glScalef(x, y, z);

  if (textureFlag == GL_FALSE){
    glColor3f(0.7, 0.7, 0.2);
  }
  else{
    if (t % 3 == 0) glBindTexture(GL_TEXTURE_2D, building_texture1);

    else glBindTexture(GL_TEXTURE_2D, building_texture2);    
  }

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 1.0, 0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.5, 1.0, -0.5);
    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 1.0, -0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(0.5, 1.0, 0.5);
  glEnd();    

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 0.0, 0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.5, 0.0, -0.5);
    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 0.0, -0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(0.5, 0.0, 0.5);

  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.5, 1.0, -0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(0.5, 1.0, 0.5);
    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 0.0, 0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(0.5, 0.0, -0.5);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 1.0, -0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.5, 1.0, 0.5);
    glTexCoord2d(1.0,1.0); glVertex3f(-0.5, 0.0, 0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(-0.5, 0.0, -0.5);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 1.0, -0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.5, 0.0, -0.5);
    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 0.0, -0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(0.5, 1.0, -0.5);
  glEnd();


  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(-0.5, 1.0, 0.5);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.5, 0.0, 0.5);
    glTexCoord2d(1.0,1.0); glVertex3f(0.5, 0.0, 0.5);
    glTexCoord2d(0.0,1.0); glVertex3f(0.5, 1.0, 0.5);
  glEnd();

  glPopMatrix();
}

// -------------------
// Desenha Cidade
// -------------------

void draw_city(void)
{
  int i, j, k, l;
    
  k = 2; 
  l = 5;
  
  if (textureFlag == GL_FALSE){
    glColor3f(0.5, 0.5, 0.5);
  }
  else{ 
    glBindTexture(GL_TEXTURE_2D, asphalt_texture1);    
  }

  glPushMatrix();   

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.0, 0.0);
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, 0.0, CITY_HEIGHT * 3.0);
    glTexCoord2d(1.0,1.0); glVertex3f(CITY_WIDTH * 6.0, 0.0, CITY_HEIGHT * 3.0);
    glTexCoord2d(0.0,1.0); glVertex3f(CITY_WIDTH * 6.0, 0.0, 0.0);
  glEnd();  

  glTranslatef(1.5, 0.0, 1.5);

  for(i = 0;i < CITY_HEIGHT; i++){
    glPushMatrix();   
 
    for(j = 0; j < CITY_WIDTH; j++){
      if (i % k == 0) draw_building(2.0, 6.0, 2.0, i + j); 
      else draw_house(2.0, 1.0, 2.0, i + j); 

      glTranslatef(3.0, 0.0, 0.0);
 
      if (i % l == 0) draw_house(2.0, 1.0, 2.0, i + j); 
      else draw_building(2.0, 6.0, 2.0, i + j); 

      glTranslatef(3.0, 0.0, 0.0);
    }    

    glPopMatrix(); 
    glTranslatef(0.0, 0.0, 3.0);
  }

  glPopMatrix();   
}

// ---------------------------
// Desenha Pista de Decolagem
// ---------------------------

void draw_track(void)
{    
  if (textureFlag == GL_FALSE){
    glColor3f(0.5, 0.0, 0.0);
  }
  else{ 
    glBindTexture(GL_TEXTURE_2D, sand_texture2);    
  }

  glPushMatrix();   

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.0, 0.0);
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, 0.0, TRACK_HEIGHT * 3.0);
    glTexCoord2d(1.0,1.0); glVertex3f(TRACK_WIDTH * 6.0, 0.0, TRACK_HEIGHT * 3.0);
    glTexCoord2d(0.0,1.0); glVertex3f(TRACK_WIDTH * 6.0, 0.0, 0.0);
  glEnd();   

  if (textureFlag == GL_FALSE){
    glColor3f(0.0, 0.0, 1.0);
  }
  else{ 

    glBindTexture(GL_TEXTURE_2D, asphalt_texture2);    
  }

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(TRACK_WIDTH * 3.0 - 3.0, 0.05, 3.0);
    glTexCoord2d(1.0,0.0); glVertex3f(TRACK_WIDTH * 3.0 - 3.0, 0.05, TRACK_HEIGHT * 3.0 - 3.0);
    glTexCoord2d(1.0,1.0); glVertex3f(TRACK_WIDTH * 3.0 + 3.0, 0.05, TRACK_HEIGHT * 3.0 - 3.0);
    glTexCoord2d(0.0,1.0); glVertex3f(TRACK_WIDTH * 3.0 + 3.0, 0.05, 3.0);
  glEnd(); 

  glTranslatef(TRACK_WIDTH * 1.5, 0.0, TRACK_HEIGHT * 1.5);


  draw_house(4.0, 2.0, 4.0, 1);   
  
  glPopMatrix();                     
}

// -----------------------
// Desenha aviao de papel
// -----------------------

void draw_paper_airplane(void)

{
  glScalef(3.0, 3.0, 3.0);

  if (textureFlag == GL_FALSE){
    glColor3f(0.5, 0.5, 0.5);
  }
  else{ 
    glBindTexture(GL_TEXTURE_2D, paper_texture);
  }

  // Asas

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.15, +0.75);
    glTexCoord2d(1.0,0.0); glVertex3f(0.1, 0.15, -0.75);

    glTexCoord2d(1.0,1.0); glVertex3f(0.4, 0.15, -0.75);
  glEnd();


  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.15, +0.75);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.1, 0.15, -0.75);
    glTexCoord2d(1.0,1.0); glVertex3f(-0.4, 0.15, -0.75);
  glEnd();

  // Parte Inferior

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.15, +0.75);
    glTexCoord2d(1.0,0.0); glVertex3f(0.1, 0.15, -0.75);
    glTexCoord2d(1.0,1.0); glVertex3f(0.0, -0.15, -0.75);
  glEnd();   

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.15, +0.75);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.1, 0.15, -0.75);
    glTexCoord2d(1.0,1.0); glVertex3f(0.0, -0.15, -0.75);
  glEnd();  

  // Dobras interiores

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.15, +0.75);
    glTexCoord2d(1.0,0.0); glVertex3f(0.05, 0.22, 0.0);
    glTexCoord2d(1.0,1.0); glVertex3f(0.2, 0.15, 0.0);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.15, +0.75);
    glTexCoord2d(1.0,0.0); glVertex3f(0.05, 0.22, 0.0);
    glTexCoord2d(1.0,1.0); glVertex3f(0.0, 0.1, 0.0);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.15, +0.75);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.05, 0.22, 0.0);
    glTexCoord2d(1.0,1.0); glVertex3f(-0.2, 0.15, 0.0);
  glEnd();

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 0.15, +0.75);
    glTexCoord2d(1.0,0.0); glVertex3f(-0.05, 0.22, 0.0);
    glTexCoord2d(1.0,1.0); glVertex3f(0.0, 0.1, 0.0);
  glEnd();  

}

// -------------------
// Desenha ambiente
// -------------------

void draw_environment(void)
{
  int i;


  glPushMatrix();  

  // Sky


  if (textureFlag == GL_FALSE){
    glColor3f(0.5, 0.5, 1.0);
  }
  else{ 
    glBindTexture(GL_TEXTURE_2D, sky_texture);
  }

  glBegin(GL_POLYGON);

    glTexCoord2d(0.0,0.0); glVertex3f(0.0, BOUND_Y, 0.0);
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, BOUND_Y, BOUND_Z);
    glTexCoord2d(1.0,1.0); glVertex3f(BOUND_X, BOUND_Y, BOUND_Z);
    glTexCoord2d(0.0,1.0); glVertex3f(BOUND_X, BOUND_Y, 0.0);
  glEnd();

  // Clouds

  if (textureFlag == GL_FALSE){
    glColor3f(0.3, 0.3, 0.6);
  }
  else{ 
    glBindTexture(GL_TEXTURE_2D, clouds_texture);
  }

  glBegin(GL_POLYGON);
    glTexCoord2d(0.0,0.0); glVertex3f(0.0, 3.0 * CITY_HEIGHT, 0.0);
    glTexCoord2d(1.0,0.0); glVertex3f(0.0, 3.0 * CITY_HEIGHT, BOUND_Z);
    glTexCoord2d(1.0,1.0); glVertex3f(BOUND_X, 3.0 * CITY_HEIGHT, BOUND_Z);
    glTexCoord2d(0.0,1.0); glVertex3f(BOUND_X, 3.0 * CITY_HEIGHT, 0.0);
  glEnd();

  // World
  
  for(i = 0; i < 5; i++){        
    draw_forest();  
    glTranslatef(3.0 * CITY_HEIGHT, 0.0, 0.0);          
  }


  glTranslatef(-3.0 * CITY_HEIGHT, 0.0, 3.0 * CITY_HEIGHT);          
  draw_forest();
  glTranslatef(0.0, 0.0, 3.0 * CITY_HEIGHT);          

  draw_forest();
  glTranslatef(0.0, 0.0, 3.0 * CITY_HEIGHT);         

   
  for(i = 5; i > 0; i--){        
    draw_forest();  
    glTranslatef(-3.0 * CITY_HEIGHT, 0.0, 0.0);          
  }

  glTranslatef(3.0 * CITY_HEIGHT, 0.0, -3.0 * CITY_HEIGHT);          
  draw_forest();

  glTranslatef(0.0, 0.0, -3.0 * CITY_HEIGHT);          
  draw_forest();
  glTranslatef(0.0, 0.0, 3.0 * 3.0 * CITY_HEIGHT);          

  for(i = 0; i < 5; i++){        
    draw_beach();  
    glTranslatef(3.0 * CITY_HEIGHT, 0.0, 0.0);          
  }

  glTranslatef(-3.0 * CITY_HEIGHT, 0.0, 3.0 * CITY_HEIGHT);          

  for(i = 5; i > 0; i--){        
    draw_sea();  
    glTranslatef(-3.0 * CITY_HEIGHT, 0.0, 0.0);          
  }

  glTranslatef(2.0 * 3.0 * CITY_HEIGHT, 0.0, -4.0 * 3.0 * CITY_HEIGHT);          
  glScalef(1.0, 1.0, 2.0);
  draw_track();

  glTranslatef(3.0 * CITY_HEIGHT, 0.0, 0.0);    
  glScalef(2.0, 2.0, 1.0);
  draw_city();

  glPopMatrix();

  glTranslatef(5.0 * 3.0 * CITY_HEIGHT, 0.0, 12.0 * 3.0 * CITY_HEIGHT); 
  glRotatef(180.0, 0.0, 1.0, 0.0);

  for(i = 0; i < 5; i++){        
    draw_forest();  
    glTranslatef(3.0 * CITY_HEIGHT, 0.0, 0.0);          
  }

  glTranslatef(-3.0 * CITY_HEIGHT, 0.0, 3.0 * CITY_HEIGHT);          
  draw_forest();
  glTranslatef(0.0, 0.0, 3.0 * CITY_HEIGHT);          
  draw_forest();
  glTranslatef(0.0, 0.0, 3.0 * CITY_HEIGHT);         
   
  for(i = 5; i > 0; i--){        
    draw_forest();  
    glTranslatef(-3.0 * CITY_HEIGHT, 0.0, 0.0);          
  }

  glTranslatef(3.0 * CITY_HEIGHT, 0.0, -3.0 * CITY_HEIGHT);          
  draw_forest();
  glTranslatef(0.0, 0.0, -3.0 * CITY_HEIGHT);          
  draw_forest();
  glTranslatef(0.0, 0.0, 3.0 * 3.0 * CITY_HEIGHT);          

  for(i = 0; i < 5; i++){        
    draw_beach();  
    glTranslatef(3.0 * CITY_HEIGHT, 0.0, 0.0);          
  }

  glTranslatef(-3.0 * CITY_HEIGHT, 0.0, 3.0 * CITY_HEIGHT);          

  for(i = 5; i > 0; i--){        
    draw_sea();  
    glTranslatef(-3.0 * CITY_HEIGHT, 0.0, 0.0);          
  }


  glTranslatef(2.0 * 3.0 * CITY_HEIGHT, 0.0, -4.0 * 3.0 * CITY_HEIGHT);          
  glScalef(1.0, 1.0, 2.0);
  draw_track();
  glTranslatef(3.0 * CITY_HEIGHT, 0.0, 0.0);    
  glScalef(2.0, 2.0, 1.0);
  draw_city();
}


// ---------------------------------
// ------------ Dinamica -----------
// ---------------------------------

// Inicia

void posInic(void)
{
  step = 0;
  glTranslatef(CITY_HEIGHT * 4.5, 0.2, CITY_HEIGHT * 4.0); //seta a posicao inicial do aviao
  glGetFloatv(GL_MODELVIEW_MATRIX, mvmatrix);
}


// Movimento Vertical

void spinUp(void)
{
  glRotatef(-5, 1, 0, 0);
  glGetFloatv(GL_MODELVIEW_MATRIX, mvmatrix);
  glutPostRedisplay();
}

void spinDown(void)
{
  glRotatef(5, 1, 0, 0);
  glGetFloatv(GL_MODELVIEW_MATRIX, mvmatrix);
  glutPostRedisplay();
}

// Movimento de Rotacao

void spinRight(void)
{
  glRotatef(10, 0, 0, 1);
  glGetFloatv(GL_MODELVIEW_MATRIX, mvmatrix);
  glutPostRedisplay();
}

void spinLeft(void)
{
  glRotatef(-10, 0, 0, 1);
  glGetFloatv(GL_MODELVIEW_MATRIX, mvmatrix);
  glutPostRedisplay();
}

// Movimento Horizontal

void spinRightHorizontal(void)
{ 
  glRotatef(-5, 0, 1, 0);
  glGetFloatv(GL_MODELVIEW_MATRIX, mvmatrix);
  glutPostRedisplay();
}

void spinLeftHorizontal(void)
{
  glRotatef(5, 0, 1, 0);
  glGetFloatv(GL_MODELVIEW_MATRIX, mvmatrix);
  glutPostRedisplay();
}


// ---------------------------------
// ------------ Funcoes ------------
// ---------------------------------

// Funcao temporal

void timerFunc(int value)
{ 
  glTranslatef(0.0, 0.0, step);
  glGetFloatv(GL_MODELVIEW_MATRIX, mvmatrix);
  
  if ((mvmatrix[14] < 0.0) || (mvmatrix[14] > BOUND_Z) || (mvmatrix[12] < 0.0) || (mvmatrix[12] > BOUND_X) || (mvmatrix[13] < 0.2) || (mvmatrix[13] > BOUND_Y))

    glTranslatef(0.0, 0.0, -step);
  
  glutPostRedisplay(); 
 
  if (pauseFlag == GL_FALSE) glutTimerFunc(DELAY,timerFunc,value); 
  else glutTimerFunc(DELAY,NULL,value);
}

// Funcoes do GLUT:

// Funcao para teclas de controle do aviao

void specialKeyboard(int key, int x, int y)
{
  (void) x;
  (void) y;
  switch (key)
  {
    case GLUT_KEY_DOWN:
      if (pauseFlag == GL_FALSE) spinUp();
    break;


    case GLUT_KEY_UP:
      if (pauseFlag == GL_FALSE) spinDown();

    break;

    case GLUT_KEY_LEFT:      
      if (pauseFlag == GL_FALSE)
        if (glutGetModifiers() != GLUT_ACTIVE_SHIFT) spinLeftHorizontal();        
        else spinLeft(); 
    break;

    case GLUT_KEY_RIGHT:     
      if (pauseFlag == GL_FALSE)
        if (glutGetModifiers() != GLUT_ACTIVE_SHIFT)
          spinRightHorizontal();
        else spinRight();
    break;

    case GLUT_KEY_F4:     
      if (windowFlag == GL_TRUE){
        windowFlag = GL_FALSE; 
        glutFullScreen();
      }
      else{
        windowFlag = GL_TRUE;        
        glutPositionWindow(50,50);
        glutReshapeWindow(600, 600);
      }
    break;

    default:
      break; 
  }  
}

void FreeTexture(GLuint texture);

// Funcao para navegacao no programa

void keyboard(unsigned char key, int x, int y)
{
  (void) x;
  (void) y;
  switch (key)
  {      
    case 'a': //acelera
      if (pauseFlag == GL_FALSE){
        if (step < 3.0) step += 0.5; 
      }
    break;

    case 'z': //freia
      if (pauseFlag == GL_FALSE){ 
        if (step > 0.0) step -= 0.5; 
      }
    break;

    case 'w': //wire
      if (wireFlag == GL_TRUE){
        glPolygonMode(GL_FRONT, GL_FILL);  
        glPolygonMode(GL_BACK, GL_FILL);
        wireFlag = GL_FALSE;        
      }  
      else{
        glPolygonMode(GL_FRONT, GL_LINE);  

        glPolygonMode(GL_BACK, GL_LINE);
        wireFlag = GL_TRUE;   
      }     
      glutPostRedisplay();
    break;

    case 't': //texture
      if (textureFlag == GL_TRUE){
        textureFlag = GL_FALSE; 
        glDisable(GL_TEXTURE_2D);
      }
      else{
        textureFlag = GL_TRUE;       
        glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
        glEnable(GL_TEXTURE_2D);
      }
      glutPostRedisplay();
    break;

    case 'r': //reset
      glLoadIdentity();

      posInic();
      glutPostRedisplay();
    break; 

    case 'p': //pause
      if (pauseFlag == GL_TRUE){
        pauseFlag = GL_FALSE; 
        glutTimerFunc(DELAY,timerFunc,0);    
      }
      else{
        pauseFlag = GL_TRUE;
      }
      glutPostRedisplay();
    break; 

    case 27:
      FreeTexture(roof_texture1);
      FreeTexture(roof_texture2);
      FreeTexture(wall_texture1);
      FreeTexture(wall_texture2);
      FreeTexture(building_texture1);
      FreeTexture(building_texture2);
      FreeTexture(asphalt_texture1);
      FreeTexture(asphalt_texture2);
      FreeTexture(wood_texture1);
      FreeTexture(wood_texture2);
      FreeTexture(leafs_texture1);
      FreeTexture(leafs_texture2);
      FreeTexture(earth_texture);

      FreeTexture(sand_texture1);
      FreeTexture(sand_texture2);
      FreeTexture(sea_texture);
      FreeTexture(clouds_texture);
      FreeTexture(sky_texture);
      FreeTexture(paper_texture);
      exit(0);
    break;

    default:
      break; 
   }
}

// Funcoes Auxiliares:

// Carrega arquivo com textura

GLuint loadTextureRAW( const char * filename, int wrap, int width, int height )
{
  GLuint texture;
  BYTE * data;
  FILE * file;

  // open texture data
  file = fopen( filename, "rb" );
  if ( file == NULL ) return 0;

  // allocate buffer
  data = (BYTE *) malloc( width * height * 3 );

  // read texture data
  fread( data, width * height * 3, 1, file );
  fclose( file );

  // allocate a texture name
  glGenTextures( 1, &texture );

  // select our current texture
  glBindTexture( GL_TEXTURE_2D, texture );

  // select modulate to mix texture with color for shading
  glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

  // when texture area is small, bilinear filter the closest MIP map
  glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
                   GL_LINEAR_MIPMAP_NEAREST );
  // when texture area is large, bilinear filter the first MIP map
  glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

  // if wrap is true, the texture wraps over at the edges (repeat)
  //       ... false, the texture ends at the edges (clamp)
  glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,
                   wrap ? GL_REPEAT : GL_CLAMP );
  glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T,
                   wrap ? GL_REPEAT : GL_CLAMP );

  // build our texture MIP maps
  gluBuild2DMipmaps( GL_TEXTURE_2D, 3, width,
    height, GL_RGB, GL_UNSIGNED_BYTE, data );

  // free buffer
  free( data );

  return texture;
}

// Escreve na tela

void printString(GLfloat x, GLfloat y, char *string, void *font)
{
  int len, i;
  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++)
     glutBitmapCharacter(font, string[i]);
 }

void FreeTexture(GLuint texture)
{
  glDeleteTextures(1, &texture);
}

void init(void){    
  roof_texture1 = loadTextureRAW("roof1.raw", TRUE, 314, 395);
  roof_texture2 = loadTextureRAW("roof2.raw", TRUE, 317, 396);
  wall_texture1 = loadTextureRAW("wall1.raw", TRUE, 248, 170);
  wall_texture2 = loadTextureRAW("wall2.raw", TRUE, 640, 480);
  building_texture1 = loadTextureRAW("building1.raw", TRUE, 327, 500);
  building_texture2 = loadTextureRAW("building2.raw", TRUE, 301, 425);
  asphalt_texture1 = loadTextureRAW("asphalt1.raw", TRUE, 400, 320);
  asphalt_texture2 = loadTextureRAW("asphalt2.raw", TRUE, 474, 331);
  wood_texture1 = loadTextureRAW("wood1.raw", TRUE, 180, 170);
  wood_texture2 = loadTextureRAW("wood2.raw", TRUE, 184, 133);
  leafs_texture1 = loadTextureRAW("leafs1.raw", TRUE, 244, 163);
  leafs_texture2 = loadTextureRAW("leafs2.raw", TRUE, 200, 200);
  earth_texture = loadTextureRAW("earth.raw", TRUE, 128, 128);
  sand_texture1 = loadTextureRAW("sand1.raw", TRUE, 200, 200);
  sand_texture2 = loadTextureRAW("sand2.raw", TRUE, 281, 365);
  sea_texture = loadTextureRAW("sea.raw", TRUE, 128, 128);
  clouds_texture = loadTextureRAW("clouds.raw", TRUE, 640, 480);
  sky_texture = loadTextureRAW("sky.raw", TRUE, 256, 256);  
  paper_texture = loadTextureRAW("paper.raw", TRUE, 256, 256);

  /* select clearing (background) color */
  
  glClearColor(0.0, 0.0, 0.0, 0.0);
  glShadeModel(GL_FLAT);  
  glEnable(GL_DEPTH_TEST);  

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum (-1.0, 1.0, -1.0, 1.0, 1.0, BOUND_Z);

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_MODELVIEW);

  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
  glEnable(GL_TEXTURE_2D);
  glPolygonMode(GL_FRONT, GL_FILL);  
  glPolygonMode(GL_BACK, GL_FILL);

  posInic();
}


// ---------------------------------
// ------------ Visoes -------------
// ---------------------------------

// Visao do piloto

void airplane_sight(void)
{
  GLfloat aux[16];
  aux[0] = mvmatrix[0];
  aux[1] = mvmatrix[4];
  aux[2] = mvmatrix[8];
  aux[3] = mvmatrix[3];
  aux[4] = mvmatrix[1];
  aux[5] = mvmatrix[5];
  aux[6] = mvmatrix[9];
  aux[7] = mvmatrix[7];
  aux[8] = mvmatrix[2];
  aux[9] = mvmatrix[6];
  aux[10] = mvmatrix[10];
  aux[11] = mvmatrix[11];
  aux[12] = 0.0;
  aux[13] = 0.0;
  aux[14] = 0.0;
  aux[15] = 1.0;

  glLoadIdentity();

  glRotatef(180,0,1,0);

  glMultMatrixf(aux);
  glTranslatef(-mvmatrix[12], -mvmatrix[13], -mvmatrix[14]);

  glPushMatrix();  
  draw_environment();
  glPopMatrix();

  glMultMatrixf(mvmatrix);
  draw_paper_airplane();  
}

// Visao da torre

void tower_sight(void)
{
  glLoadIdentity();

  gluLookAt(TOWER_X, TOWER_Y, TOWER_Z, mvmatrix[12], mvmatrix[13], mvmatrix[14], 0.0, 1.0, 0.0);

  glPushMatrix();
  draw_environment();
  glPopMatrix(); 
  
  glMultMatrixf(mvmatrix);
  draw_paper_airplane();
}

// Visao do aviao amigo

void friend_sight(void)
{
  glLoadIdentity();


  gluLookAt(mvmatrix[12] + 3, mvmatrix[13] + 3, mvmatrix[14] - 3, mvmatrix[12], mvmatrix[13], mvmatrix[14], 0.0, 1.0, 0.0);

  glPushMatrix();

  draw_environment();
  glPopMatrix();
  
  glMultMatrixf(mvmatrix);

  draw_paper_airplane();
}

// Menu

void draw_menu(void)
{
	glLoadIdentity();

	glTranslatef(0.0, 0.0, -3.0);
	
	printString(-1.5, 2, "Flight Simulator", GLUT_BITMAP_HELVETICA_18);
	printString(-1.5, 1.8, "_____________", GLUT_BITMAP_HELVETICA_18);

	printString(-2.5,1, "Commands:", GLUT_BITMAP_HELVETICA_12);

	printString(-2.5, 0.5, "down", GLUT_BITMAP_HELVETICA_12);
	printString(-0.9, 0.5, ":", GLUT_BITMAP_HELVETICA_12);
	printString(-0.6, 0.5, "go up", GLUT_BITMAP_HELVETICA_12);

	printString(-2.5, 0.0, "up", GLUT_BITMAP_HELVETICA_12);
	printString(-0.9, 0.0, ":", GLUT_BITMAP_HELVETICA_12);
	printString(-0.6, 0.0, "go down", GLUT_BITMAP_HELVETICA_12);

	printString(-2.5, -0.5, "left", GLUT_BITMAP_HELVETICA_12);
	printString(-0.9, -0.5, ":", GLUT_BITMAP_HELVETICA_12);
	printString(-0.6, -0.5, "turn left", GLUT_BITMAP_HELVETICA_12);

	printString(-2.5, -1.0, "right", GLUT_BITMAP_HELVETICA_12);
	printString(-0.9, -1.0, ":", GLUT_BITMAP_HELVETICA_12);
	printString(-0.6, -1.0, "turn right", GLUT_BITMAP_HELVETICA_12);

	printString(-2.5, -1.5, "shift + left", GLUT_BITMAP_HELVETICA_12);
	printString(-0.9, -1.5, ":", GLUT_BITMAP_HELVETICA_12);
	printString(-0.6, -1.5, "rotate left", GLUT_BITMAP_HELVETICA_12);

	printString(-2.5, -2.0, "shift + right", GLUT_BITMAP_HELVETICA_12);
	printString(-0.9, -2.0, ":", GLUT_BITMAP_HELVETICA_12);
	printString(-0.6, -2.0, "rotate right", GLUT_BITMAP_HELVETICA_12);

	printString(-2.5, -2.5, "esc", GLUT_BITMAP_HELVETICA_12);
	printString(-0.9, -2.5, ":", GLUT_BITMAP_HELVETICA_12);
	printString(-0.6, -2.5, "exit", GLUT_BITMAP_HELVETICA_12);

	printString(0.9, 0.5, "a", GLUT_BITMAP_HELVETICA_12);
	printString(1.2, 0.5, ":", GLUT_BITMAP_HELVETICA_12);
	printString(1.5, 0.5, "speed up", GLUT_BITMAP_HELVETICA_12);

	printString(0.9, 0.0, "z", GLUT_BITMAP_HELVETICA_12);
	printString(1.2, 0.0, ":", GLUT_BITMAP_HELVETICA_12);
	printString(1.5, 0.0, "speed down", GLUT_BITMAP_HELVETICA_12);

	printString(0.9, -0.5, "p", GLUT_BITMAP_HELVETICA_12);
	printString(1.2, -0.5, ":", GLUT_BITMAP_HELVETICA_12);
	printString(1.5, -0.5, "pause", GLUT_BITMAP_HELVETICA_12);

	printString(0.9, -1.0, "F4", GLUT_BITMAP_HELVETICA_12);
	printString(1.2, -1.0, ":", GLUT_BITMAP_HELVETICA_12);
	printString(1.5, -1.0, "fullscreen", GLUT_BITMAP_HELVETICA_12);

	printString(0.9, -1.5, "w", GLUT_BITMAP_HELVETICA_12);
	printString(1.2, -1.5, ":", GLUT_BITMAP_HELVETICA_12);
	printString(1.5, -1.5, "wire", GLUT_BITMAP_HELVETICA_12);

	printString(0.9, -2.0, "t", GLUT_BITMAP_HELVETICA_12);
	printString(1.2, -2.0, ":", GLUT_BITMAP_HELVETICA_12);
	printString(1.5, -2.0, "texture", GLUT_BITMAP_HELVETICA_12);

	printString(0.9, -2.5, "r", GLUT_BITMAP_HELVETICA_12);
	printString(1.2, -2.5, ":", GLUT_BITMAP_HELVETICA_12);
	printString(1.5, -2.5, "reset", GLUT_BITMAP_HELVETICA_12);
}

void reshape(int w, int h)
{        
  width = w;
  height = h;
}


void display(void)
{
  glPushMatrix(); //guarda o sc. do aviao
  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glViewport(0, 0, (GLsizei) width/2, (GLsizei) height/2);
  friend_sight();

  glViewport(width/2, 0, (GLsizei) width/2, (GLsizei) height/2);
  tower_sight();

  glViewport(0, height/2, (GLsizei) width/2, (GLsizei) height/2);
  airplane_sight();

  glViewport(width/2, height/2, (GLsizei) width/2, (GLsizei) height/2);
  draw_menu();

  glPopMatrix(); //volta o sc. do aviao
  
  glFlush();    
  glutSwapBuffers(); 
}


// ---------------------------------
// ------ Programa Principal -------
// ---------------------------------

/* Declare initial window size, position and display mode (double buffer and RGBA). 
   Call initialization routines. Register callback function to display
   graphics. Enter main loops and process events
*/


int main(int argc, char** argv){  
  
  // Inicializacao do OpenGL

      
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutInit(&argc, argv);
  glutInitWindowSize(600, 600); 
  glutInitWindowPosition(50,50); 
  glutCreateWindow("Flight Simulator");
  init();

 
  /* Register routine 'display' as the callback function that is invoked
     whenever the system needs to redisplay the window */
  
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(keyboard);
  glutSpecialFunc(specialKeyboard); 
  glutTimerFunc(DELAY,timerFunc,0);    
  glutSetCursor(GLUT_CURSOR_FULL_CROSSHAIR);

  glutMainLoop();
      
  FreeTexture(roof_texture1);
  FreeTexture(roof_texture2);
  FreeTexture(wall_texture1);
  FreeTexture(wall_texture2);
  FreeTexture(building_texture1);
  FreeTexture(building_texture2);
  FreeTexture(asphalt_texture1);
  FreeTexture(asphalt_texture2);
  FreeTexture(wood_texture1);
  FreeTexture(wood_texture2);
  FreeTexture(leafs_texture1);
  FreeTexture(leafs_texture2);
  FreeTexture(earth_texture);

  FreeTexture(sand_texture1);
  FreeTexture(sand_texture2);
  FreeTexture(sea_texture);
  FreeTexture(clouds_texture);
  FreeTexture(sky_texture);
  FreeTexture(paper_texture);

  return 0;
}
